CrystalPlayer = Fill:extend{
   fill = {255,0,0},
   height = 32,
   width = 32,
   onStartFrame = function(self)
                     if the.mouse:pressed() then
                        print('hi')
                     end

                     local dx = love.mouse.getX() - the.app.width / 2
                     local dy = love.mouse.getY() - the.app.height / 2

                     self.acceleration.x = dx * 10
                     self.acceleration.y = dy * 10

                     --print(dx, dy)

                     love.mouse.setPosition(the.app.width /2, the.app.height/2)
                  end
}

local velLimit = 400
--local velLimit = 50
SpacePlayer = WrapTile:extend{
   image = 'data/ship.png',
   maxVelocity = {x=velLimit,y=velLimit},
   minVelocity = {x=-velLimit, y=-velLimit},
   lastFired = 0,
   onStartFrame = function(self)
                     --- TAKE 2

                     local mouseVec = vector.new(
                        love.mouse.getX() - the.app.width / 2,
                        love.mouse.getY() - the.app.height / 2
                     )

                     self.rotation = math.atan2(mouseVec.y, mouseVec.x)

                     if mouseVec:len2() > 64^2 then
                        self.acceleration = vector.new(300, 0)
                        self.acceleration:rotate_inplace(self.rotation)
                     else
                        self.acceleration = {x=0, y=0}
                        if DEBUG and the.console.visible then
                           self.velocity = {x=0, y=0}
                        end
                     end

                     if the.mouse:pressed() and -- assumes left button
                       love.timer.getTime() - self.lastFired > 0.25 and
                       the.cursor:inTargetArea() then
                           --print('pew')
                           b = Bullet:new{
                              x = self.x, y = self.y,
                           }
                           the.app.view:add(b)
                           self.lastFired = love.timer.getTime()
                     end
                  end,
   onUpdate = function(self)
              end
}